import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;

@SuppressWarnings("serial") 
public class HTick10av2 extends Canvas{
	private Color backColor;
	private Color foreColor;
	private String caption;
	private int width;
	private int height;
	private int stringWidth;
	private int xcoordinate;
	private int ycoordinate;
	private Image image;
	private Graphics graphics;

	public HTick10av2(){
		setBackground(null);
	}

	public void setDimensions(Dimension dimension,int i){
		this.width=dimension.width-i*2;
		this.height=dimension.height-i*2;
		this.setBounds(i,i,this.width,this.height);
		FontMetrics fontmetrics=this.getFontMetrics(this.getFont());
		int fontAscent=fontmetrics.getAscent();
		int fontDescent=fontmetrics.getDescent();
		int fontSize=this.getFont().getSize();
		if(fontAscent>fontSize){
			fontAscent=fontSize;
		}
		if(fontAscent/4<fontDescent){
			fontDescent=fontAscent/4;
		}
		this.ycoordinate=(this.height-(fontAscent+fontDescent))/2+fontAscent;
		this.stringWidth=fontmetrics.stringWidth(this.caption);
	}

	@Override public void paint(Graphics g){
		if(this.image==null){
			this.image=createImage(this.width,this.height);
			this.graphics=this.image.getGraphics();
			this.graphics.setFont(getFont());
			this.xcoordinate=this.width;
			return;
		}
		this.xcoordinate-=2;
		int i=this.xcoordinate+this.stringWidth;
		if(i<=0){
			this.xcoordinate=i;
			i=this.width;
		}
		this.graphics.setColor(this.foreColor);
		this.graphics.fillRect(0,0,this.width,this.height);
		this.graphics.setColor(this.backColor);
		this.graphics.drawString(this.caption,this.xcoordinate,this.ycoordinate);
		if(i<this.width){
			this.graphics.drawString(this.caption,i,this.ycoordinate);
		}
		g.drawImage(this.image,0,0,null);
	}

	@Override public void update(Graphics g){
		this.paint(g);
	}

	@Override public void finalize(){
		if(this.graphics!=null){
			this.graphics.dispose();
		}
	}

	public void setBackColor(Color backColor){
		this.backColor=backColor;
	}

	public void setForeColor(Color foreColor){
		this.foreColor=foreColor;
	}

	public void setCaption(String caption){
		this.caption=caption;
	}
}