import java.applet.Applet;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.util.StringTokenizer;

@SuppressWarnings("serial") public class HTick10v2 extends Applet implements Runnable{
	private Thread thread;
	private Dimension dimension;
	private HTick10av2 canvas;
	private int borderstyle;
	private int borderwidth;
	private int scrollspeed;
	private Color bordercolor;

	public HTick10v2(){ /* not implemented */}

	@Override public void init(){
		this.setLayout(null);
		this.dimension=getSize();
		this.canvas=new HTick10av2();
		readParameters();
		this.canvas.setDimensions(this.dimension,this.borderwidth);
		this.add(this.canvas);
	}

	@Override public String getAppletInfo(){
		return "HTick10 v1.00 original release\r\n(c) Java Hermit 1998\r\nwww.celticedge.com/hermit/\r\nnon-functional changes by Hugues Johnson 2009";
	}

	private int parseInt(String s,int i,int j,int k){
		int l=0;
		if(s!=null){
			try{
				l=Integer.parseInt(s);
			} catch(NumberFormatException _ex){ /* not implemented */}
			if(l<i)
				l=i;
			else if(l>j)
				l=j;
		} else{
			l=k;
		}
		return l;
	}

	private String readParameter(String s){
		String s1;
		if((s1=getParameter(s))!=null){
			return s1.trim();
		}
		return null;
	}

	private Color parseColor(String s,int i){
		int j;
		if(s!=null)
			try{
				if(s.startsWith("0x"))
					j=Integer.parseInt(s.substring(2),16);
				else if(s.startsWith("#"))
					j=Integer.parseInt(s.substring(1),16);
				else
					j=Integer.parseInt(s,10);
			} catch(NumberFormatException _ex){
				j=i;
			}
			else
				j=i;
		if(j>-1){
			return new Color(j);
		}
		return null;
	}

	private Font parseFont(String s){
		if(s!=null)
			try{
				StringTokenizer stringtokenizer=new StringTokenizer(s,",");
				if(stringtokenizer.countTokens()==3)
					return new Font(stringtokenizer.nextToken(),Integer.parseInt(stringtokenizer.nextToken()),Integer.parseInt(stringtokenizer.nextToken()));
			} catch(Exception x){
				/* not implemented */
			}
			return new Font("Helvetica",0,12);
	}

	private void readParameters(){
		try{
			this.canvas.setFont(parseFont(readParameter("textfont")));
			this.borderwidth=parseInt(readParameter("borderwidth"),0,8,1);
			this.borderstyle=parseInt(readParameter("borderstyle"),0,8,1);
			this.bordercolor=parseColor(readParameter("bordercolor"),0xcccccc);
			this.canvas.setBackColor(parseColor(readParameter("textcolor"),0xffffff));
			this.canvas.setForeColor(parseColor(readParameter("backcolor"),0));
			this.scrollspeed=parseInt(readParameter("scrollspeed"),5,999,25);
			int i=parseInt(readParameter("captionspace"),1,99,10);
			StringBuffer stringbuffer=new StringBuffer();
			StringBuffer stringbuffer1=new StringBuffer(i);
			for(int j=0;j<i;j++)
				stringbuffer1.append(" ");

			int k=1;
			String s;
			while((s=getParameter("caption"+k++))!=null){
				stringbuffer.append(s);
				stringbuffer.append(stringbuffer1.toString());
			}
			if(stringbuffer.length()<1){
				stringbuffer.append("caption parameter is null or empty ");
			} else{
				stringbuffer.append(stringbuffer1.toString());
			}
			this.canvas.setCaption(stringbuffer.toString());
			return;
		} catch(Exception exception){
			this.showStatus("HTick10: Parameter error: "+exception);
		}
	}

	private void draw(Graphics g){
		int i=0;
		int j=this.dimension.width-1;
		int k=this.dimension.height-1;
		g.setColor(this.bordercolor);
		// if(this.borderstyle==1||this.borderstyle==4){
		g.fillRect(0,0,this.dimension.width,this.dimension.height);
		// }
		while(i<this.borderwidth){
			switch(this.borderstyle){
			default:
				break;

			case 1: // '\001'
				return;

			case 2: // '\002'
				g.draw3DRect(i,i,j,k,i!=this.borderwidth-1||this.borderwidth<=1);
				break;

			case 3: // '\003'
				g.draw3DRect(i,i,j,k,i==0&&this.borderwidth>1);
				break;

			case 4: // '\004'
				if(i==0&&this.borderwidth>1){
					g.draw3DRect(i,i,j,k,true);
					break;
				}
				if(i==this.borderwidth-1&&this.borderwidth>1)
					g.draw3DRect(i,i,j,k,false);
				break;
			}
			i++;
			j-=2;
			k-=2;
		}
	}

	@Override public void paint(Graphics g){
		if(this.borderwidth>0)
			draw(g);
	}

	@Override public void update(Graphics g){
		paint(g);
	}

	@Override public void start(){
		if(this.thread==null){
			this.thread=new Thread(this);
			this.thread.start();
		}
	}

	@Override public void stop(){
		if(this.thread!=null){
			this.thread=null;
		}
	}

	public void run(){
		Thread.currentThread().setPriority(1);
		do
			try{
				Thread.sleep(this.scrollspeed);
				this.canvas.repaint();
			} catch(InterruptedException _ex){
				stop();
			}
			while(true);
	}
}